//
//  ViewController.m
//  NSNotificationExample
//
//  Created by KH1386 on 3/17/14.
//  Copyright (c) 2014 KH1386. All rights reserved.
//

#import "ViewController.h"

@interface ViewController ()

@end

@implementation ViewController

-(void) receivedNotification:(NSNotification*) notification
{

    NSString * name =notification.name;
    NSDictionary * info =notification.userInfo;
    
    NSLog(@"Received Notification with name =%@",name);
    NSLog(@"Information =%@",info);
    
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    
    [[NSNotificationCenter defaultCenter] addObserver:self
                                             selector:@selector(receivedNotification:)
                                                 name:@"NOTIFICATION_1" object:nil];
    
    [[NSNotificationCenter defaultCenter] addObserver:self
                                             selector:@selector(receivedNotification:)
                                                 name:@"NOTIFICATION_2" object:nil];
    
    
	// Do any additional setup after loading the view, typically from a nib.
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

-(IBAction) sendNotification1:(id)sender
{
    NSNumber * sliderValue =[NSNumber numberWithFloat:self.slider.value];
    NSDictionary * dict =[NSDictionary dictionaryWithObject:sliderValue forKey:@"slider"];
    NSNotification * notification =[[ NSNotification alloc]
                                    initWithName:@"NOTIFICATION_1" object:nil userInfo:dict];
    
    [[NSNotificationCenter defaultCenter] postNotification:notification];
    
}
-(IBAction) sendNotification2:(id)sender
{
    NSString * noticationName =@"NOTIFICATION_2";

    NSDictionary * dict =[NSDictionary dictionaryWithObject:@"Ravi" forKey:@"name"];
    NSNotification * notification =[[ NSNotification alloc]
                                    initWithName:noticationName object:nil userInfo:dict];
    
    
    //EX 1: with NSNotification object
    [[NSNotificationCenter defaultCenter] postNotification:notification];
    
    //EX 2: without Userinfo and without preparing NSNotification object
    [[NSNotificationCenter defaultCenter] postNotificationName:noticationName object:nil];
    
    //EX 3: without preparing NSNotification Object
    [[NSNotificationCenter defaultCenter] postNotificationName:noticationName
                                                        object:nil userInfo:dict];
    
    
}

-(IBAction) unRegister:(id)sender
{
    NSString * noticationName =@"NOTIFICATION_2";

    //EX 1: unreigster all the notifications in the object.
    [[NSNotificationCenter defaultCenter] removeObserver:self];
  
    //EX 2: unregister specific notification
    [[NSNotificationCenter defaultCenter] removeObserver:self name:noticationName object:nil];
}


@end
